#!/bin/bash

set -e
#must be at least 6 characters
truststore_path=/usr/xtee/apache2/misp2truststore.jks
keystore_path=/usr/xtee/apache2/misp2keystore.jks
tomcat_path=/etc/default/tomcat7  
add_sec_cert=n
tomcat_restart=$1
tomcat_home=/var/lib/tomcat7
tomcat_init=/etc/init.d/tomcat7
cd /usr/xtee/apache2/
rm -rf misp2truststore.jks
rm -rf misp2keystore.jks

echo "Creating ssl certificate"
echo -n "Please add Security server certificate proxycert.tar.gz to the RoksNet Portal server directory /usr/xtee/apache2/?( answering 'no' means that HTTPS configuration is not done this time ) [y/n] [default: n] "
read add_sec_cert < /dev/tty
if [ "$add_sec_cert" == "" ]
then
	add_sec_cert="n"
fi
if [ `echo $add_sec_cert | grep -i y ` ]
then
	while [ ! -f /usr/xtee/apache2/proxycert.tar.gz ]; do
		echo -n "Please add Security server certificate proxycert.tar.gz to the RoksNet Portal server directory /usr/xtee/apache2/?( answering 'no' means that HTTPS configuration is not done this time ) [y/n] [default: n] "
		read add_sec_cert < /dev/tty
		if [ "$add_sec_cert" == "" ]
		then
			add_sec_cert="n"
		fi
		if [ `echo $add_sec_cert | grep -i y ` ]
		then
			continue
		else
			exit
		fi
	done
	tar xzvf proxycert.tar.gz
	if [ -f /usr/xtee/apache2/cert.der ]
	then
		while [  "$truststore_password" == "" -o ${#truststore_password} -lt 6 ] ; do
			echo -n "Enter truststore password (must be at least 6 characters): "
			read truststore_password < /dev/tty
		done
		while [  "$keystore_password" == "" -o ${#keystore_password} -lt 6 ]; do
			echo -n "Enter keystore password (must be at least 6 characters): "
			read keystore_password < /dev/tty
        done
		keytool -import -keystore misp2truststore.jks -file cert.der -storepass $truststore_password

		sh /etc/apache2/ssl/create_sslproxy_cert.sh

		openssl pkcs12 -export -in sslproxy.cert -inkey sslproxy.key -out misp2.p12 -passout pass:$keystore_password

		keytool -importkeystore -srcstoretype PKCS12 -srckeystore misp2.p12 -destkeystore misp2keystore.jks -keypass $keystore_password -deststorepass $keystore_password -srcstorepass $keystore_password

		if grep "trustStore=" $tomcat_path 
		then
			sed -i '/trustStore=.*/c\JAVA_OPTS="${JAVA_OPTS} -Djavax.net.ssl.trustStore='$truststore_path'"' $tomcat_path 
		else
			echo JAVA_OPTS='"${JAVA_OPTS}' -Djavax.net.ssl.trustStore=$truststore_path'"' >> $tomcat_path
		fi
		if grep "trustStorePassword=" $tomcat_path
		then
			sed -i '/trustStorePassword=.*/c\JAVA_OPTS="${JAVA_OPTS} -Djavax.net.ssl.trustStorePassword='$truststore_password'"' $tomcat_path 
		else
			echo JAVA_OPTS='"${JAVA_OPTS}' -Djavax.net.ssl.trustStorePassword=$truststore_password'"' >> $tomcat_path
		fi
		if grep "keyStore=" $tomcat_path 
		then
			sed -i '/keyStore=.*/c\JAVA_OPTS="${JAVA_OPTS} -Djavax.net.ssl.keyStore='$keystore_path'"' $tomcat_path 
		else
			echo JAVA_OPTS='"${JAVA_OPTS}' -Djavax.net.ssl.keyStore=$keystore_path'"' >> $tomcat_path
		fi
		if grep "keyStorePassword=" $tomcat_path
		then
			sed -i '/keyStorePassword=.*/c\JAVA_OPTS="${JAVA_OPTS} -Djavax.net.ssl.keyStorePassword='$keystore_password'"' $tomcat_path 
		else
			echo JAVA_OPTS='"${JAVA_OPTS}' -Djavax.net.ssl.keyStorePassword=$keystore_password'"' >> $tomcat_path
		fi
		if [ `echo $tomcat_restart | grep -i omitrestart ` ]
        then
			echo "Tomcat restart is omitted..."
		else
            echo "Restarting Tomcat..."
            if [ ! -f $tomcat_init ]
            then
                echo "Shutdown Tomcat..."
				$tomcat_home/bin/shutdown.sh
                echo "Tomcat starting up..."
                $tomcat_home/bin/startup.sh
            else
                /etc/init.d/tomcat7 restart
            fi	
        fi
		mv sslproxy.cert cert.der
		echo "Get cert.der from /usr/xtee/apache2/ and add it to your security server"
	else
		echo "Security server certificate cert.der not found in /usr/xtee/apache2/"
	fi
fi
